;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 150 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "twi3.vec"
	.INCLUDE "twi3.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xF6)
	LDI  R29,HIGH(0xF6)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xF6
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot solaire
;      10 Version : 1
;      11 Date    : 17/08/2009
;      12 Author  : MNO                             
;      13 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      14 Comments: Mise en oeuvre du protocole I2C sur l'interface TWI
;      15 Transfert de l'tat des BP sur les LEDs de la carte (PCF8574)
;      16 Adaptation de la note d'application AVR315 d'ATMEL
;      17 Lecture de la ddp batterie sur la carte MD23
;      18 Commande des moteurs de la carte MD23
;      19 
;      20 Chip type           : ATmega8535
;      21 Program type        : Application
;      22 Clock frequency     : 8,000000 MHz
;      23 Memory model        : Small
;      24 External SRAM size  : 0
;      25 Data Stack size     : 128
;      26 *********************************************/
;      27 
;      28 #include <mega8535.h>
;      29 #include <string.h>
;      30 #include <stdlib.h>
;      31 #include <MD23.h>
;      32 #include <delay.h>  
;      33 
;      34 // Redfinition du buffer TWI dfini dans le fichier MD23.h
;      35 #define TWI_BUFFER_SIZE 	20
;      36 
;      37 #include "TWI_F.c" // Fonctions du drivers TWI adaptes pour CVAVR 
;      38 /***********************************************************************
;      39 Project : PPE Robot(s)
;      40 Version : 1
;      41 Date    : 12/08/2009
;      42 Author  : MNO
;      43 File : twi_f.c
;      44 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      45 et dcrites dans la note d'application AVR315, adaptes au
;      46 cross compilateur CVAVR.
;      47 Fichier  inclure en en tte d'une application ncessitant une interface
;      48 2 fil I2C.
;      49 Evolution:  remplacer par une bibliothque
;      50 ***********************************************************************/
;      51 
;      52 
;      53 #include <TWI_Master_CVAVR.h>  
;      54 
;      55 
;      56 // Declare your global variables here 
;      57 //-----------------------------------------------------------------------------------------------------------------------------
;      58 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      59 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      60 static unsigned char TWI_state = TWI_NO_STATE;      	// State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      61  
;      62 union TWI_STR                      			// Status byte holding flags.
;      63 {
;      64     unsigned char all;
;      65     unsigned char lastTransOK:1;      
;      66     unsigned char unusedBits:7; 
;      67 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      68 //-----------------------------------------------------------------------------------------------------------------------------
;      69 
;      70 //-----------------------------------------------------------------------------------------------------------------------------
;      71 // Fonctions du drivers TWI
;      72 //-----------------------------------------------------------------------------------------------------------------------------
;      73 void TWI_Master_Initialise(void)
;      74 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      75   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      76 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      77   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      78   						//  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;      79   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;      80                                			// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;      81                                			// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;      82                                          	// 0<<TWWC); 
;      83 } 
	RET
;      84 //-----------------------------------------------------------------------------------------------------------------------------
;      85 unsigned char TWI_Transceiver_Busy(void)
;      86 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;      87   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;      88 }
;      89 //-----------------------------------------------------------------------------------------------------------------------------
;      90 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;      91 {
_TWI_Start_Transc_With_Data:
;      92   unsigned char temp;
;      93                                                 // Adapte pour CVAVR
;      94   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x38:
	RCALL SUBOPT_0x0
	BRNE _0x38
;      95 
;      96   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;      97   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;      98   if (!( msg[0] & 0b00000001 ))       		// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x3B
;      99   {						// If it is a write operation, then also copy data.
;     100     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x3D:
	RCALL SUBOPT_0x2
	BRSH _0x3E
;     101       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x5
	RJMP _0x3D
_0x3E:
;     102   }
;     103   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x3B:
	CLR  R30
	STS  _TWI_statusReg,R30
;     104   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     105   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     106                            			// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     107                 				// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     108                                       		// (0<<TWWC);
;     109 } 
	RJMP _0x73
;     110 //-----------------------------------------------------------------------------------------------------------------------------
;     111 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     112 {
_TWI_Get_Data_From_Transceiver:
;     113   unsigned char i;
;     114           
;     115   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0x40:
	RCALL SUBOPT_0x0
	BRNE _0x40
;     116 
;     117   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x6
	BREQ _0x43
;     118   {                                             
;     119     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x45:
	RCALL SUBOPT_0x2
	BRSH _0x46
;     120     {
;     121       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     122     }
	RCALL SUBOPT_0x5
	RJMP _0x45
_0x46:
;     123   }
;     124   return( TWI_statusReg.lastTransOK );                                   
_0x43:
	RCALL SUBOPT_0x6
_0x73:
	ADIW R28,4
	RET
;     125 }  
;     126 //-----------------------------------------------------------------------------------------------------------------------------
;     127 
;     128 // ----------------------------------------------------------------------------------------------------------------------------
;     129 // Interruption TWI
;     130 // ----------------------------------------------------------------------------------------------------------------------------
;     131 interrupt [TWI] void twi_isr(void)      // Adapte pour CVAVR
;     132 {					// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     133 					// __interrupt void TWI_ISR(void)
;     134   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     135   
;     136   switch (TWSR)
	IN   R30,0x1
;     137   {
;     138     case TWI_START:             // START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x4C
;     139     
;     140     case TWI_REP_START:         // Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x4D
_0x4C:
;     141       TWI_bufPtr = 0;   	// Set buffer pointer to the TWI Address location
	CLR  R4
;     142       				
;     143     case TWI_MTX_ADR_ACK:       // SLA+W has been tramsmitted and ACK received 
	RJMP _0x4E
_0x4D:
	CPI  R30,LOW(0x18)
	BRNE _0x4F
_0x4E:
;     144     
;     145     case TWI_MTX_DATA_ACK:      // Data byte has been tramsmitted and ACK received
	RJMP _0x50
_0x4F:
	CPI  R30,LOW(0x28)
	BRNE _0x51
_0x50:
;     146       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x52
;     147       {
;     148         TWDR = TWI_buf[TWI_bufPtr++];                     // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x7
	LD   R30,Z
	OUT  0x3,R30
;     149         TWCR = 0b10000101;                                // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x74
;     150                                      			  // (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     151                          				  // (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     152                						  // (0<<TWWC); 
;     153       }
;     154       else                    // Send STOP after last byte
_0x52:
;     155       {
;     156         TWI_statusReg.lastTransOK = TRUE;                 // Set status bits to completed successfully.
	RCALL SUBOPT_0x8
;     157          						  // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     158         TWCR = 0b10010100; 		                  // (1<<TWEN)| TWI Interface enabled
_0x74:
	OUT  0x36,R30
;     159                                     			  // (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     160                          				  // (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     161                                				  // (0<<TWWC);
;     162       }
;     163     break;
	RJMP _0x4A
;     164       
;     165     case TWI_MRX_DATA_ACK:      // Data byte has been received and ACK tramsmitted
_0x51:
	CPI  R30,LOW(0x50)
	BRNE _0x54
;     166       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x7
	MOVW R26,R30
	RCALL SUBOPT_0x9
;     167       
;     168     case TWI_MRX_ADR_ACK:       // SLA+R has been tramsmitted and ACK received
	RJMP _0x55
_0x54:
	CPI  R30,LOW(0x40)
	BRNE _0x56
_0x55:
;     169       if (TWI_bufPtr < (TWI_msgSize-1) )                  // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x57
;     170       {                                                   // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     171         TWCR = 0b10000101;                                // (1<<TWEN)| TWI Interface enabled
;     172                                      			  // (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     173                           				  // (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     174                                                           // (0<<TWWC);  
;     175       }else                    // Send NACK after next reception
_0x57:
;     176       {						          // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     177         TWCR = 0b10000101;                                // (1<<TWEN)| TWI Interface enabled
_0x75:
	LDI  R30,LOW(133)
	OUT  0x36,R30
;     178                                      			  // (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     179                           				  // (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     180                                 			  // (0<<TWWC); 
;     181       }    
;     182     break; 
	RJMP _0x4A
;     183       
;     184     case TWI_MRX_DATA_NACK:     // Data byte has been received and NACK tramsmitted
_0x56:
	CPI  R30,LOW(0x58)
	BRNE _0x59
;     185       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0x9
;     186       TWI_statusReg.lastTransOK = TRUE;                 // Set status bits to completed successfully. 
	RCALL SUBOPT_0x8
;     187       							// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     188       TWCR = 0b10010100;                                // (1<<TWEN)| TWI Interface enabled
	RJMP _0x76
;     189                                   			// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     190                        					// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     191                                              		// (0<<TWWC); 
;     192     break;  
;     193           
;     194     case TWI_ARB_LOST:          // Arbitration lost                             
_0x59:
	CPI  R30,LOW(0x38)
	BRNE _0x5A
;     195     							// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     196       TWCR = 0b10100101;                                // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x76
;     197                                    			// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     198                         				// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     199                                               		// (0<<TWWC);
;     200     break;
;     201       
;     202     case TWI_MTX_ADR_NACK:      // SLA+W has been tramsmitted and NACK received
_0x5A:
	CPI  R30,LOW(0x20)
	BREQ _0x5C
;     203     case TWI_MRX_ADR_NACK:      // SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0x5D
_0x5C:
;     204     case TWI_MTX_DATA_NACK:     // Data byte has been tramsmitted and NACK received
	RJMP _0x5E
_0x5D:
	CPI  R30,LOW(0x30)
	BRNE _0x5F
_0x5E:
;     205 //    case TWI_NO_STATE              // No relevant state information available; TWINT = 0
;     206     case TWI_BUS_ERROR:         // Bus error due to an illegal START or STOP condition  
	RJMP _0x60
_0x5F:
	CPI  R30,0
	BRNE _0x62
_0x60:
;     207     
;     208     default:     
_0x62:
;     209       TWI_state = TWSR;                                 // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     210                                                         // Reset TWI Interface
;     211                                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     212       TWCR = 0b00000100;                                // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x76:
	OUT  0x36,R30
;     213                                    			// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     214                        					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     215                                               		// (0<<TWWC);
;     216   }
_0x4A:
;     217 } 
	RCALL __LOADISR
	RETI
;     218 
;     219 
;     220 // Constantes en flash
;     221 // ==========================================================================================================
;     222 // ==================================== Messages pour le LCD I2C BATRON =====================================
;     223 // ==========================================================================================================
;     224 // Trames d'initialisation de l'afficheur LCD I2C BATRON (voir doc PCF2119x p22  p25)
;     225 /* ----------------------------------------------------------------------------------------------------------
;     226 Ordre   Dsignation					Valeur		Remarques
;     227 // ----------------------------------------------------------------------------------------------------------
;     228 1 	Adresse de l'afficheur 			=	0x76 		(SA0 = 1) ( envoyer en premier)
;     229 2 	Select function setting			=	0x00 		Doit prcder une ou plusieurs commandes 
;     230 									(dans la trame I2C !) doc PCF2119x p22
;     231 									voir doc PCF2119x p22
;     232 3 	Command : Function set			=	0x34            2 lignes de 16 caractres 
;     233 4 	Command : Display control		=	0x0c            Display on, curseur off
;     234 5 	Command : Entry mode set		=       0x06  		Incrment, no shift
;     235 6	Command : Extended instruction set	= 	0x35            ----------------------------------
;     236 7	Command : Set display configuration	= 	0x04  		left-to-right, top to bottom 
;     237 8	Command : Set coefficient temperature	= 	0x10            TC1 = 0, TC2 = 0 (Default)
;     238 9	Command : Set Internal HVgen stages	=	0x42            HV stage 3  ???
;     239 10	Command : Set VLCD			= 	0x9F            set VLCD, store VA (Rglage contraste)
;     240 11	Command : Normal instruction set	= 	0x34            ----------------------------------
;     241 12	Command : Set DDRRAM address		= 	0x80            DDRAM address = 0x00
;     242 ----------------------------------------------------------------------------------------------------------*/
;     243 flash unsigned char LCD_BATRON_Init[13]={0x76,0x00,0x34,0x0c,0x06,0x35,0x04,0x10,0x42,0x9F,0x34,0x80,0x02};
;     244 
;     245 
;     246 
;     247 // Fonctions
;     248 // ---------------------------------------------------------------------------------------------------------- 
;     249      
;     250   
;     251  
;     252 
;     253 
;     254 // ----------------------------------------------------------------------------------------------------------
;     255 // Boucle principale
;     256 // ----------------------------------------------------------------------------------------------------------
;     257 void main(void)
;     258 {
_main:
;     259 // Declare your local variables here 
;     260 unsigned char Message_For_TWI_Buffer[20];
;     261 unsigned char Switch_All_LED_On[]={0x40,0x00}; 	// Pour clairer toutes les LED {addLed + W (0x40), data = all Led on}
;     262 unsigned char Switch_LED_On[]={0x40,0x00}; 	// Pour clairer des LED {addLed + W (0x40), data = Led on}
;     263 unsigned char Switch_All_LED_Off[]={0x40,0xff}; 	// Pour teindre toutes les LED {addLed + W (ox40), data = all Led off}
;     264 unsigned char Accueil_Lcd[]={0x76,0x40,'P','h','i','l','i','p','s'};
;     265 unsigned char Read_BP[]={0x43,0x00}; 		// Pour lire les BP {addBP +R (0x43), data=nothing} 
;     266 unsigned char Valeur_Registre_MD23; 
;     267 char Valeur_Registre_MD23_Texte[]={'','',''};
;     268 
;     269 unsigned char Trame_LCD_ligne1[18] = {0x76,0x40,'R'+0x80,'v',0xA0,0xA0,'M','o','d',0xA0,0xA0,'U'+0x80,'='+0x80,
;     270 0xA0,0xA0,'.'+0x80,0xA0,0xd6};
;     271 
;     272 // ==========================================================================================================
;     273 // ==================================== Messages pour le LCD I2C BATRON =====================================
;     274 // ==========================================================================================================
;     275 // 	Command : Clear display			= 	0x01   
;     276 // ----------------------------------------------------------------------------------------------------------
;     277 unsigned char LCD_BATRON_Clear[]={0x76,0x00,0x01}; 
;     278 
;     279 // ----------------------------------------------------------------------------------------------------------
;     280 
;     281 
;     282 
;     283 // ==========================================================================================================
;     284 // ==================================== Messages pour la carte MD23 =========================================
;     285 // ========================================================================================================== 
;     286 // Gnral
;     287 unsigned char Reset_MD23[]={MD23_ADRESSE_BASE,Reg_Commande, Reset_Encodeur};
;     288 unsigned char Mode0_MD23[]={MD23_ADRESSE_BASE,Reg_Mode,Mode2};
;     289 unsigned char Registre_MD23[]={0xff, 0};
;     290 
;     291 // Vitesse des moteurs
;     292 unsigned char Speed1[]={MD23_ADRESSE_BASE,Reg_Speed1, 137};
;     293 unsigned char Speed2[]={MD23_ADRESSE_BASE,Reg_Speed2_Turn, 128};  
;     294 unsigned char Time_OUT_Desable[]={MD23_ADRESSE_BASE,Reg_Commande, Desactive_Timeout_Moteurs};
;     295 
;     296 // Tension batterie   
;     297 unsigned char Read_UBatt_MD23_1[]={MD23_ADRESSE_BASE,Reg_VBatterie};//   add_SoftRev add_Enc1a    add_
;     298 unsigned char Read_UBatt_MD23_2[]={MD23_ADRESSE_BASE | 1, 0};
;     299  
;     300 
;     301 
;     302 unsigned char i, valeur=128,taille_message;
;     303 // ==========================================================================================================
;     304 
;     305 TWI_Master_Initialise(); 	// Initialisation de l'interface TWI en mode Standby
	SBIW R28,63
	SBIW R28,19
	LDI  R24,62
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x64*2)
	LDI  R31,HIGH(_0x64*2)
	RCALL __INITLOCB
;	Message_For_TWI_Buffer -> Y+62
;	Switch_All_LED_On -> Y+60
;	Switch_LED_On -> Y+58
;	Switch_All_LED_Off -> Y+56
;	Accueil_Lcd -> Y+47
;	Read_BP -> Y+45
;	Valeur_Registre_MD23 -> R16
;	Valeur_Registre_MD23_Texte -> Y+42
;	Trame_LCD_ligne1 -> Y+24
;	LCD_BATRON_Clear -> Y+21
;	Reset_MD23 -> Y+18
;	Mode0_MD23 -> Y+15
;	Registre_MD23 -> Y+13
;	Speed1 -> Y+10
;	Speed2 -> Y+7
;	Time_OUT_Desable -> Y+4
;	Read_UBatt_MD23_1 -> Y+2
;	Read_UBatt_MD23_2 -> Y+0
;	i -> R17
;	valeur -> R18
;	taille_message -> R19
	LDI  R18,128
	RCALL _TWI_Master_Initialise
;     306 
;     307 // Global enable interrupts
;     308 #asm("sei")
	sei
;     309 
;     310 // ------------------------------------ Initialisations ---------------------------------------------------------
;     311 // --------------------------------------------------------------------------------------------------------------
;     312 TWI_Start_Transc_With_Data(Switch_All_LED_Off,sizeof(Switch_All_LED_Off)); 
	MOVW R30,R28
	ADIW R30,56
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     313 
;     314 
;     315 // Copie de la table LCD_BATRON_Init dans le tableau de variables Message_For_TWI_Buffer
;     316 for (i=0;i<13;i++)
	LDI  R17,LOW(0)
_0x66:
	CPI  R17,13
	BRSH _0x67
;     317 {
;     318 	Message_For_TWI_Buffer[i]=LCD_BATRON_Init[i];
	RCALL SUBOPT_0xB
	MOVW R26,R28
	ADIW R26,62
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	LDI  R26,LOW(_LCD_BATRON_Init*2)
	LDI  R27,HIGH(_LCD_BATRON_Init*2)
	RCALL SUBOPT_0xB
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     319 } 
	SUBI R17,-1
	RJMP _0x66
_0x67:
;     320 	       		
;     321 TWI_Start_Transc_With_Data(Message_For_TWI_Buffer,sizeof(LCD_BATRON_Init));                 
	MOVW R30,R28
	ADIW R30,62
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(13)
	RCALL SUBOPT_0xC
;     322 
;     323 
;     324 // Initialisation de la carte MD23
;     325 // --------------------------------------------------------------------------------------------------------------
;     326 TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));
	MOVW R30,R28
	ADIW R30,18
	RCALL SUBOPT_0xD
;     327 TWI_Start_Transc_With_Data(Time_OUT_Desable,3);
	MOVW R30,R28
	ADIW R30,4
	RCALL SUBOPT_0xD
;     328 TWI_Start_Transc_With_Data(Mode0_MD23,3);
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0xD
;     329 TWI_Start_Transc_With_Data(Speed1,3);
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0xD
;     330 TWI_Start_Transc_With_Data(Speed2,3);
	MOVW R30,R28
	ADIW R30,7
	RCALL SUBOPT_0xD
;     331 
;     332 
;     333 
;     334 // Test afficheur BATRON 
;     335 TWI_Start_Transc_With_Data(LCD_BATRON_Clear,sizeof(LCD_BATRON_Clear));
	RCALL SUBOPT_0xE
;     336 TWI_Start_Transc_With_Data(Accueil_Lcd,sizeof(Accueil_Lcd));    // Message d'accueil  
	MOVW R30,R28
	ADIW R30,47
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	RCALL SUBOPT_0xC
;     337 delay_ms(3000);
	RCALL SUBOPT_0xF
;     338 TWI_Start_Transc_With_Data(LCD_BATRON_Clear,sizeof(LCD_BATRON_Clear));
	RCALL SUBOPT_0xE
;     339 delay_ms(3000);
	RCALL SUBOPT_0xF
;     340 
;     341 while (1)
_0x68:
;     342       { 
;     343 // ----------------------------------  Lecture des donnes -------------------------------------------------------- 
;     344 // Lecture des BP
;     345 	TWI_Start_Transc_With_Data(Read_BP,1);  		// Envoi octet d'adresse des BP + bit RW=lecture(0x43)
	MOVW R30,R28
	ADIW R30,45
	RCALL SUBOPT_0x10
;     346         TWI_Get_Data_From_Transceiver(Read_BP, 2 );  		// Lecture du buffer (octet1=add, octet2=donnee etat BP) 
	MOVW R30,R28
	ADIW R30,45
	RCALL SUBOPT_0xA
	RCALL _TWI_Get_Data_From_Transceiver
;     347 
;     348 // Lecture des info de la carte MD23
;     349 // Tension d'alimentation  
;     350       
;     351         TWI_Start_Transc_With_Data(Read_UBatt_MD23_1,2);        //  Envoi octet d'adresse MD23 + dcalage + bit RW=criture
	MOVW R30,R28
	ADIW R30,2
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     352         TWI_Start_Transc_With_Data(Read_UBatt_MD23_2,1);        //  Envoi octet d'adresse MD23 +  bit RW=lecture
	MOVW R30,R28
	RCALL SUBOPT_0x10
;     353         TWI_Get_Data_From_Transceiver(Registre_MD23,2);  	//  Lecture tension alim de la carte MD23
	MOVW R30,R28
	ADIW R30,13
	RCALL SUBOPT_0xA
	RCALL _TWI_Get_Data_From_Transceiver
;     354         Valeur_Registre_MD23 = Registre_MD23[1];  
	LDD  R16,Y+14
;     355         
;     356 // ----------------------------------  Traitement ------------------------------------------------------------------        
;     357         
;     358         Switch_LED_On[1]=~Read_BP[1];                  		// Transfert etat BP dans message LED On
	LDD  R30,Y+46
	COM  R30
	STD  Y+59,R30
;     359          
;     360         itoa((unsigned int)Valeur_Registre_MD23,Valeur_Registre_MD23_Texte);     
	MOV  R30,R16
	CLR  R31
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,44
	ST   -Y,R31
	ST   -Y,R30
	RCALL _itoa
;     361         
;     362         if(Valeur_Registre_MD23<10)
	CPI  R16,10
	BRSH _0x6B
;     363         {
;     364          Trame_LCD_ligne1[2]=Valeur_Registre_MD23_Texte[0]+0x80;
	RCALL SUBOPT_0x11
;     365          Trame_LCD_ligne1[3]=0xA0;
	LDI  R30,LOW(160)
	RCALL SUBOPT_0x12
;     366          Trame_LCD_ligne1[4]=0xA0;
;     367         } 
;     368         else if(Valeur_Registre_MD23<100)
	RJMP _0x6C
_0x6B:
	CPI  R16,100
	BRSH _0x6D
;     369         {
;     370          Trame_LCD_ligne1[2]=Valeur_Registre_MD23_Texte[0]+0x80;
	RCALL SUBOPT_0x11
;     371          Trame_LCD_ligne1[3]=Valeur_Registre_MD23_Texte[1]+0x80;
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x12
;     372          Trame_LCD_ligne1[4]=0xA0;
;     373         } 
;     374         else 
	RJMP _0x6E
_0x6D:
;     375          for (i=0;i<sizeof(Valeur_Registre_MD23_Texte);i++)
	LDI  R17,LOW(0)
_0x70:
	CPI  R17,3
	BRSH _0x71
;     376         {
;     377          Trame_LCD_ligne1[13]=Valeur_Registre_MD23_Texte[0]+0x80;
	LDD  R30,Y+42
	SUBI R30,-LOW(128)
	STD  Y+37,R30
;     378          Trame_LCD_ligne1[14]=Valeur_Registre_MD23_Texte[1]+0x80;
	RCALL SUBOPT_0x13
	STD  Y+38,R30
;     379          Trame_LCD_ligne1[16]=Valeur_Registre_MD23_Texte[2]+0x80;
	LDD  R30,Y+44
	SUBI R30,-LOW(128)
	STD  Y+40,R30
;     380         }
	SUBI R17,-1
	RJMP _0x70
_0x71:
_0x6E:
_0x6C:
;     381 
;     382                 
;     383 // ----------------------------------  Ecriture sur les LED et l'afficheur  -----------------------------------------
;     384         TWI_Start_Transc_With_Data(LCD_BATRON_Clear,sizeof(LCD_BATRON_Clear));    
	RCALL SUBOPT_0xE
;     385         TWI_Start_Transc_With_Data(Trame_LCD_ligne1,sizeof(Trame_LCD_ligne1));
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	RCALL SUBOPT_0xC
;     386         TWI_Start_Transc_With_Data(Switch_LED_On,2);   		// Commande des LED
	MOVW R30,R28
	ADIW R30,58
	RCALL SUBOPT_0xA
	RCALL _TWI_Start_Transc_With_Data
;     387         delay_ms(200);     
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;     388       };
	RJMP _0x68
;     389 }
	ADIW R28,63
	ADIW R28,19
_0x72:
	RJMP _0x72
;     390 
;     391 

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	MOV  R30,R17
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0xC:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xE:
	MOVW R30,R28
	ADIW R30,21
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDD  R30,Y+42
	SUBI R30,-LOW(128)
	STD  Y+26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	STD  Y+27,R30
	LDI  R30,LOW(160)
	STD  Y+28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDD  R30,Y+43
	SUBI R30,-LOW(128)
	RET

_itoa:
	ld   r26,y+
	ld   r27,y+
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	brpl __itoa0
	com  r30
	com  r31
	adiw r30,1
	ldi  r22,'-'
	st   x+,r22
__itoa0:
	clt
	ldi  r24,low(10000)
	ldi  r25,high(10000)
	rcall __itoa1
	ldi  r24,low(1000)
	ldi  r25,high(1000)
	rcall __itoa1
	ldi  r24,100
	clr  r25
	rcall __itoa1
	ldi  r24,10
	rcall __itoa1
	mov  r22,r30
	rcall __itoa5
	clr  r22
	st   x,r22
	ret
__itoa1:
	clr	 r22
__itoa2:
	cp   r30,r24
	cpc  r31,r25
	brlo __itoa3
	inc  r22
	sub  r30,r24
	sbc  r31,r25
	brne __itoa2
__itoa3:
	tst  r22
	brne __itoa4
	brts __itoa5
	ret
__itoa4:
	set
__itoa5:
	subi r22,-0x30
	st   x+,r22
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

