;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 160 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "twi3MD23.vec"
	.INCLUDE "twi3MD23.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x100)
	LDI  R29,HIGH(0x100)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x100
;       1 /********************************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : PPE Robot solaire
;      10 Version : 3
;      11 Date    : 06/01/2010
;      12 Author  : Philippe Mariano                            
;      13 Company : Lyce Pierre Emile Martin 18000 BOURGES                                
;      14 Comments: Fichier de la fiche guide 2
;      15 Mise en oeuvre du protocole I2C par l'interface TWI 
;      16 Commande d'un afficheur LCD Batron I2C (PCF2119x)
;      17 Lecture des BP et recopie sur les LED. 
;      18 Programme de test de la carte MD23(Reglage et commande des moteurs en
;      19 Mode0, lecture et affichage des registres)
;      20 
;      21 File : twi3MD23.c
;      22 Target:  Robot S_ISI
;      23 Chip type           : ATmega8535
;      24 Program type        : Application
;      25 Clock frequency     : 8,000000 MHz
;      26 Memory model        : Small
;      27 External SRAM size  : 0
;      28 Data Stack size     : 128
;      29 *********************************************************************/
;      30 
;      31 // =============================================================================================================================
;      32 // Bibliothques et dfinitions
;      33 // =============================================================================================================================
;      34 #include <mega8535.h>      
;      35 // -----------------------------------------------------------------------------------------------------------------------------
;      36 // Bibliothque  rajouter manuellement   
;      37 // -----------------------------------------------------------------------------------------------------------------------------
;      38 #include <stdlib.h> 
;      39 #include <stdio.h>				// Fonction sprintf
;      40 #include <math.h>
;      41 #include <string.h>				// Fonctions de traitement des chanes de caractres  
;      42 #include <delay.h>				// Fonction temporisation     
;      43 #include <MD23.h>				// Dfinitions des registres de la carte moteur MD23  
;      44 #include <ssi.h>                // Fonctions de lecture/criture des priphriques I2C
;      45 // -----------------------------------------------------------------------------------------------------------------------------
;      46 // Redfinition du buffer TWI dclar dans le fichier twi_master_cvavr.h et appel des fonctions TWI
;      47 // -----------------------------------------------------------------------------------------------------------------------------
;      48 #define TWI_BUFFER_SIZE   20 			// A placer avant l'appelle de TWI_F.c sinon TWI_BUFFER_SIZE=4 !!!!!!!!!
;      49 	
;      50 #include "TWI_F.c" 			   			// Fonctions du driver TWI Master (adaptation de la note ATMEL AVR315 -> CVAVR) 
;      51 /***********************************************************************
;      52 Project : PPE Robot(s)
;      53 Version : 1
;      54 Date    : 12/08/2009
;      55 Author  : MNO
;      56 File : twi_f.c
;      57 Description : Fonctions du drivers TWI (I2C), dveloppes par ATMEL
;      58 et dcrites dans la note d'application AVR315, adaptes au
;      59 cross compilateur CVAVR.
;      60 Fichier  inclure en en tte d'une application ncessitant une interface
;      61 2 fil I2C.
;      62 Evolution:  remplacer par une bibliothque
;      63 ***********************************************************************/
;      64 
;      65 
;      66 #include <TWI_Master_CVAVR.h>  
;      67 
;      68 // Declare your global variables here 
;      69 //-----------------------------------------------------------------------------------------------------------------------------
;      70 static unsigned char TWI_msgSize;             		// Number of bytes to be transmitted.       
_TWI_msgSize_G1:
	.BYTE 0x1
;      71 static unsigned char TWI_buf[TWI_BUFFER_SIZE];    	// Transceiver buffer
_TWI_buf_G1:
	.BYTE 0x14
;      72 static unsigned char TWI_state = TWI_NO_STATE;      // State byte. Default set to TWI_NO_STATE 
_TWI_state_G1:
	.BYTE 0x1
;      73  
;      74 union TWI_STR                      					// Status byte holding flags.
;      75 {
;      76     unsigned char all;
;      77     unsigned char lastTransOK:1;      
;      78     unsigned char unusedBits:7; 
;      79 } TWI_statusReg ={0};  
_TWI_statusReg:
_0TWI_statusReg:
	.BYTE 0x1
;      80 //-----------------------------------------------------------------------------------------------------------------------------
;      81 
;      82 //-----------------------------------------------------------------------------------------------------------------------------
;      83 // Fonctions du drivers TWI
;      84 //-----------------------------------------------------------------------------------------------------------------------------
;      85 void TWI_Master_Initialise(void)
;      86 {                                               // Adapte pour CVAVR

	.CSEG
_TWI_Master_Initialise:
;      87   TWBR = TWI_TWBR;                              // Set bit rate register (Baudrate). Defined in header file.
	LDI  R30,LOW(32)
	OUT  0x0,R30
;      88 // TWSR = TWI_TWPS;                             // Not used. Driver presumes prescaler to be 00.
;      89   TWDR = 0xFF;                                  // Default content = SDA released.
	LDI  R30,LOW(255)
	OUT  0x3,R30
;      90   												// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;      91   TWCR = 0b00000100;                            // (1<<TWEN)| Enable TWI-interface and release TWI pins.
	LDI  R30,LOW(4)
	OUT  0x36,R30
;      92                                					// (0<<TWIE)|(0<<TWINT)|Disable Interupt.
;      93                                					// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests.
;      94                                          		// 0<<TWWC); 
;      95 } 
	RET
;      96 //-----------------------------------------------------------------------------------------------------------------------------
;      97 unsigned char TWI_Transceiver_Busy(void)
;      98 {                                               // Adapte pour CVAVR
_TWI_Transceiver_Busy:
;      99   return ( TWCR & 0b00000001);                  // ( TWCR & (1<<TWIE) ) IF TWI Interrupt is enabled then the Transceiver is busy
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
;     100 }
;     101 //-----------------------------------------------------------------------------------------------------------------------------
;     102 void TWI_Start_Transc_With_Data( unsigned char *msg, unsigned char msgSize )
;     103 {
_TWI_Start_Transc_With_Data:
;     104   unsigned char temp;
;     105                                                 // Adapte pour CVAVR
;     106   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	temp -> Y+0
_0x7E:
	RCALL SUBOPT_0x0
	BRNE _0x7E
;     107 
;     108   TWI_msgSize = msgSize;                        // Number of data to transmit.
	LDD  R30,Y+1
	STS  _TWI_msgSize_G1,R30
;     109   TWI_buf[0]  = msg[0];                         // Store slave address with R/W setting.
	RCALL SUBOPT_0x1
	STS  _TWI_buf_G1,R30
;     110   if (!( msg[0] & 0b00000001 ))       			// (!( msg[0] & (TRUE<<TWI_READ_BIT) ))
	RCALL SUBOPT_0x1
	ANDI R30,LOW(0x1)
	BRNE _0x81
;     111   {												// If it is a write operation, then also copy data.
;     112     for ( temp = 1; temp < msgSize; temp++ )
	LDI  R30,LOW(1)
	ST   Y,R30
_0x83:
	RCALL SUBOPT_0x2
	BRSH _0x84
;     113       TWI_buf[ temp ] = msg[ temp ];
	RCALL SUBOPT_0x3
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	POP  R26
	POP  R27
	ST   X,R30
	RCALL SUBOPT_0x6
	RJMP _0x83
_0x84:
;     114   }
;     115   TWI_statusReg.all = 0;                        // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
_0x81:
	CLR  R30
	STS  _TWI_statusReg,R30
;     116   TWI_state         = TWI_NO_STATE ;            //  TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	LDI  R30,LOW(248)
	STS  _TWI_state_G1,R30
;     117   TWCR =  0b10100101;                           // (1<<TWEN)| TWI Interface enabled.
	LDI  R30,LOW(165)
	OUT  0x36,R30
;     118                            						// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag.
;     119                 								// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|Initiate a START condition!!!!!.
;     120                                       			// (0<<TWWC);
;     121 } 
	RJMP _0x206
;     122 //-----------------------------------------------------------------------------------------------------------------------------
;     123 unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
;     124 {
_TWI_Get_Data_From_Transceiver:
;     125   unsigned char i;
;     126           
;     127   while ( TWI_Transceiver_Busy() );             // Wait until TWI is ready for next transmission.
	SBIW R28,1
;	*msg -> Y+2
;	msgSize -> Y+1
;	i -> Y+0
_0x86:
	RCALL SUBOPT_0x0
	BRNE _0x86
;     128 
;     129   if( TWI_statusReg.lastTransOK )               // Last transmission competed successfully.              
	RCALL SUBOPT_0x7
	BREQ _0x89
;     130   {                                             
;     131     for ( i=0; i<msgSize; i++ )                 // Copy data from Transceiver buffer.
	CLR  R30
	ST   Y,R30
_0x8B:
	RCALL SUBOPT_0x2
	BRSH _0x8C
;     132     {
;     133       msg[ i ] = TWI_buf[ i ];
	RCALL SUBOPT_0x4
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3
	LD   R30,Z
	POP  R26
	POP  R27
	ST   X,R30
;     134     }
	RCALL SUBOPT_0x6
	RJMP _0x8B
_0x8C:
;     135   }
;     136   return( TWI_statusReg.lastTransOK );                                   
_0x89:
	RCALL SUBOPT_0x7
_0x206:
	ADIW R28,4
	RET
;     137 }  
;     138 //-----------------------------------------------------------------------------------------------------------------------------
;     139 
;     140 // ----------------------------------------------------------------------------------------------------------------------------
;     141 // Interruption TWI
;     142 // ----------------------------------------------------------------------------------------------------------------------------
;     143 interrupt [TWI] void twi_isr(void)      		// Adapte pour CVAVR
;     144 {												// #pragma vector=TWI_vect
_twi_isr:
	RCALL __SAVEISR
;     145 												// __interrupt void TWI_ISR(void)
;     146   static unsigned char TWI_bufPtr;

	.DSEG

	.CSEG
;     147   
;     148   switch (TWSR)
	IN   R30,0x1
;     149   {
;     150     case TWI_START:             				// START has been transmitted  
	CPI  R30,LOW(0x8)
	BREQ _0x92
;     151     
;     152     case TWI_REP_START:         				// Repeated START has been transmitted
	CPI  R30,LOW(0x10)
	BRNE _0x93
_0x92:
;     153       TWI_bufPtr = 0;   						// Set buffer pointer to the TWI Address location
	CLR  R4
;     154       				
;     155     case TWI_MTX_ADR_ACK:       				// SLA+W has been tramsmitted and ACK received 
	RJMP _0x94
_0x93:
	CPI  R30,LOW(0x18)
	BRNE _0x95
_0x94:
;     156     
;     157     case TWI_MTX_DATA_ACK:      				// Data byte has been tramsmitted and ACK received
	RJMP _0x96
_0x95:
	CPI  R30,LOW(0x28)
	BRNE _0x97
_0x96:
;     158       if (TWI_bufPtr < TWI_msgSize)
	LDS  R30,_TWI_msgSize_G1
	CP   R4,R30
	BRSH _0x98
;     159       {
;     160         TWDR = TWI_buf[TWI_bufPtr++];           // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
	RCALL SUBOPT_0x8
	LD   R30,Z
	OUT  0x3,R30
;     161         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
	RJMP _0x207
;     162         										// (1<<TWIE)|(1<<TWINT)|Enable TWI Interupt and clear the flag to send byte
;     163                          				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| 
;     164                						  			// (0<<TWWC); 
;     165       }
;     166       else                    					// Send STOP after last byte
_0x98:
;     167       {
;     168         TWI_statusReg.lastTransOK = TRUE;       // Set status bits to completed successfully.
	RCALL SUBOPT_0x9
;     169          						  				// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE 
;     170         TWCR = 0b10010100; 		                // (1<<TWEN)| TWI Interface enabled
_0x207:
	OUT  0x36,R30
;     171         										// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     172                          				  		// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     173                                				  	// (0<<TWWC);
;     174       }
;     175     break;
	RJMP _0x90
;     176       
;     177     case TWI_MRX_DATA_ACK:      				// Data byte has been received and ACK tramsmitted
_0x97:
	CPI  R30,LOW(0x50)
	BRNE _0x9A
;     178       TWI_buf[TWI_bufPtr++] = TWDR; 
	RCALL SUBOPT_0x8
	MOVW R26,R30
	RCALL SUBOPT_0xA
;     179       
;     180     case TWI_MRX_ADR_ACK:       				// SLA+R has been tramsmitted and ACK received
	RJMP _0x9B
_0x9A:
	CPI  R30,LOW(0x40)
	BRNE _0x9C
_0x9B:
;     181       if (TWI_bufPtr < (TWI_msgSize-1) )        // Detect the last byte to NACK it.
	LDS  R30,_TWI_msgSize_G1
	SUBI R30,LOW(1)
	CP   R4,R30
	BRSH _0x9D
;     182       {                                         // TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     183         TWCR = 0b11000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(197)
	RJMP _0x208
;     184         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     185                           				  		// (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|Send ACK after reception
;     186                                   				// (0<<TWWC);  
;     187       } else                    				// Send NACK after next reception
_0x9D:
;     188       {						          			// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     189         TWCR = 0b10000101;                      // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(133)
_0x208:
	OUT  0x36,R30
;     190         										// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag to read next byte
;     191                           				  		// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| Send NACK after reception
;     192                                 			  	// (0<<TWWC); 
;     193       }    
;     194     break; 
	RJMP _0x90
;     195       
;     196     case TWI_MRX_DATA_NACK:     				// Data byte has been received and NACK tramsmitted
_0x9C:
	CPI  R30,LOW(0x58)
	BRNE _0x9F
;     197       TWI_buf[TWI_bufPtr] = TWDR;
	MOV  R26,R4
	CLR  R27
	SUBI R26,LOW(-_TWI_buf_G1)
	SBCI R27,HIGH(-_TWI_buf_G1)
	RCALL SUBOPT_0xA
;     198       TWI_statusReg.lastTransOK = TRUE;         // Set status bits to completed successfully. 
	RCALL SUBOPT_0x9
;     199       											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     200       TWCR = 0b10010100;                        // (1<<TWEN)| TWI Interface enabled
	RJMP _0x209
;     201                                   				// (0<<TWIE)|(1<<TWINT)| Disable TWI Interrupt and clear the flag
;     202                        							// (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)| Initiate a STOP condition.
;     203                               					// (0<<TWWC); 
;     204     break;  
;     205           
;     206     case TWI_ARB_LOST:          				// Arbitration lost                             
_0x9F:
	CPI  R30,LOW(0x38)
	BRNE _0xA0
;     207     											// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     208       TWCR = 0b10100101;                        // (1<<TWEN)| TWI Interface enabled
	LDI  R30,LOW(165)
	RJMP _0x209
;     209                                    				// (1<<TWIE)|(1<<TWINT)| Enable TWI Interupt and clear the flag
;     210                         						// (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)| Initiate a (RE)START condition.
;     211                               					// (0<<TWWC);
;     212     break;
;     213       
;     214     case TWI_MTX_ADR_NACK:      				// SLA+W has been tramsmitted and NACK received
_0xA0:
	CPI  R30,LOW(0x20)
	BREQ _0xA2
;     215     case TWI_MRX_ADR_NACK:      				// SLA+R has been tramsmitted and NACK received    
	CPI  R30,LOW(0x48)
	BRNE _0xA3
_0xA2:
;     216     case TWI_MTX_DATA_NACK:     				// Data byte has been tramsmitted and NACK received
	RJMP _0xA4
_0xA3:
	CPI  R30,LOW(0x30)
	BRNE _0xA5
_0xA4:
;     217 //    case TWI_NO_STATE              			// No relevant state information available; TWINT = 0
;     218     case TWI_BUS_ERROR:         				// Bus error due to an illegal START or STOP condition  
	RJMP _0xA6
_0xA5:
	CPI  R30,0
	BRNE _0xA8
_0xA6:
;     219     
;     220     default:     
_0xA8:
;     221       TWI_state = TWSR;                         // Store TWSR and automatically sets clears noErrors bit.
	IN   R30,0x1
	STS  _TWI_state_G1,R30
;     222       											// Reset TWI Interface
;     223                  								// TWCR = TWINT TWEA TWSTA TWSTO TWWC TWEN - TWIE
;     224       TWCR = 0b00000100;                        // (1<<TWEN)| Enable TWI-interface and release TWI pins
	LDI  R30,LOW(4)
_0x209:
	OUT  0x36,R30
;     225                                    				// (0<<TWIE)|(0<<TWINT)| Disable Interupt
;     226                        							// (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)| No Signal requests
;     227                               					// (0<<TWWC);
;     228   }
_0x90:
;     229 } 
	RCALL __LOADISR
	RETI
;     230 
;     231 										// Crer une bibliothque ! 
;     232 // Dclarations divers
;     233 #define	Moteur1			0
;     234 #define	Moteur2			1
;     235 // =============================================================================================================================   
;     236 
;     237 // =============================================================================================================================
;     238 // Constantes en flash
;     239 // -----------------------------------------------------------------------------------------------------------------------------
;     240 // Structure pour l'affichage du nom des registres  (A terminer)
;     241 //flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
;     242 // -----------------------------------------------------------------------------------------------------------------------------
;     243 // Messages textuels prdfinis
;     244 // ATTENTION: imprativement 16 caractres 
;     245 // ----------------------------------------------------------------------------------------------------------------------------- 
;     246 flash char *Texte_Accueil_Ligne1 	= "   PPE Robsol   ";

	.DSEG
_Texte_Accueil_Ligne1:
	.BYTE 0x2
;     247 flash char *Texte_Accueil_Ligne2 	= "   TWI3MD23.c   ";
_Texte_Accueil_Ligne2:
	.BYTE 0x2
;     248 flash char *Ligne0MenuMode			= "1  Menu Mode    ";
_Ligne0MenuMode:
	.BYTE 0x2
;     249 flash char *Ligne0MenuInfos			= "2  Menu Infos   ";
_Ligne0MenuInfos:
	.BYTE 0x2
;     250 flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
_Ligne1PlusMoins:
	.BYTE 0x2
;     251 flash char *Ligne1ChoixEntr			= "[Entr]          ";
_Ligne1ChoixEntr:
	.BYTE 0x2
;     252 flash char *Ligne1ChoixEchap		= "        [Echap] ";
_Ligne1ChoixEchap:
	.BYTE 0x2
;     253 flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
_Ligne1ChoixEchapOk:
	.BYTE 0x2
;     254 // =============================================================================================================================
;     255 
;     256 // =============================================================================================================================
;     257 // Prototypes des fonctions en cours de test
;     258 // ----------------------------------------------------------------------------------------------------------------------------- 
;     259 // ============================================================================================================================= 
;     260  
;     261 // =============================================================================================================================
;     262 // ---------------------------------------------- Declare your global variables here -------------------------------------------
;     263 // -----------------------------------------------------------------------------------------------------------------------------
;     264 // Type				Nom														Description  
;     265 // ----------------------------------------------------------------------------------------------------------------------------- 
;     266 // Etats du graphe des transitions "Menus"
;     267 // -----------------------------------------------------------------------------------------------------------------------------
;     268 enum TMenu {Choix_Menu_Mode, Choix_Menu_Infos, Choix_Mode_MD23, Reglage_Mode0_MD23, Reglage_Mode1_MD23, Reglage_Mode2_MD23, 
;     269 Reglage_Mode3_MD23, Controle_Moteurs, Info_Batt, Info_Vers, Info_All} Menu=Choix_Menu_Mode, Menu_1=Choix_Mode_MD23;
;     270 // -----------------------------------------------------------------------------------------------------------------------------					
;     271 bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0 
;     272 // =============================================================================================================================
;     273 
;     274 // =============================================================================================================================
;     275 // =============================================================================================================================
;     276 // Partie excutive du programme 
;     277 // =============================================================================================================================
;     278 // =============================================================================================================================
;     279 void main(void)
;     280 {

	.CSEG
_main:
;     281 // =============================================================================================================================
;     282 // ---------------------------------------------- Declare your local variables here -------------------------------------------- 
;     283 // =============================================================================================================================
;     284 // Messages pour les composants I2C 
;     285 // =============================================================================================================================
;     286 // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
;     287 // ----------------------------------------------------------------------------------------------------------------------------- 
;     288 // Type 	   		Nom 				       						Description 
;     289 // ----------------------------------------------------------------------------------------------------------------------------- 
;     290 unsigned char Frame_I2C_LED_All_Off[]={0x40,0xff}; 				// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
;     291 unsigned char Frame_I2C_LED_Switching[]={0x40,0x00}; 			// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
;     292 																// or Off=1}. Initialisation = All On.
;     293 unsigned char Frame_I2C_BP_Read[]={0x43,0x00}; 					// Trame de lecture des BP {SLA+R=0x43, Data=Nul}      
;     294 // ============================================================================================================================= 
;     295 // 2) Messages pour le LCD I2C BATRON de la carte S_ISI
;     296 // ----------------------------------------------------------------------------------------------------------------------------- 
;     297 // Type 	   		Nom 				       						Description 
;     298 // ----------------------------------------------------------------------------------------------------------------------------- 
;     299 unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
;     300 unsigned char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	// Trame de texte compose de: {SLA+W=0x76, cde=write to DDRAM ,  
;     301 						 	     								// le texte  afficher = 16 caractres max,  Nul }                  
;     302                                                             	// Cette trame est remplie avec le tableau String_to_LCD
;     303 // =============================================================================================================================
;     304 // 3) Messages pour la carte MD23 
;     305 // ============================================================================================================================= 
;     306 // 31) Gnraux
;     307 unsigned char Reset_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur};
;     308 unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};
;     309 
;     310 // 32) Vitesse des moteurs 
;     311 unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur dans le mode 0
;     312 unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur dans le mode 0
;     313 unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs}; 
;     314 
;     315 // 33) Lecture des registres
;     316 unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		// Premire trame  envoyer { SLA_W=0xB0, N registre o commence
;     317 															// la lecture }
;     318 // ============================================================================================================================= 
;     319 
;     320 // =============================================================================================================================
;     321 // Variables diverses
;     322 // ----------------------------------------------------------------------------------------------------------------------------- 
;     323 // Type 		Nom 				       Description 
;     324 // -----------------------------------------------------------------------------------------------------------------------------    
;     325 // 1) Gestion de la carte MD23
;     326 // -----------------------------------------------------------------------------------------------------------------------------
;     327 int Num_Reg_MD23_1=0, Num_Reg_MD23=0;                        // Numro du registre slectionn pour l'affichage   
;     328 unsigned char Vitesse_MD23_1, Vitesse_MD23, BP_I2C=0, Finesse_1=1, Finesse=1; 
;     329 unsigned char SpeedMot1,SpeedMot1_1, SpeedMot2, SpeedMot2_1; 
;     330 unsigned char Choix_Mode_1=1, Choix_Mode=0;                                                   		
;     331 unsigned char Ubatt_1=0, Ubatt=0;							// Tension alimentation carte MD23 
;     332 unsigned char Version_1=0, Version=0; 
;     333 // -----------------------------------------------------------------------------------------------------------------------------
;     334 															// Reoit le contenu des registres de la carte MD23. Liste ci-dessous
;     335 //Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev, AccRate, Mode, Cde
;     336 unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
;     337 
;     338 // 2) Gestion du LCD BATRON
;     339 // -----------------------------------------------------------------------------------------------------------------------------
;     340  char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];     // Reoivent les deux lignes de texte  envoyer  l'afficheur
;     341 															// (16 caractres max. + Nul)
;     342 // -----------------------------------------------------------------------------------------------------------------------------
;     343 // *****************************************************************************************************************************
;     344 
;     345 // =============================================================================================================================
;     346 // ===================================================== Initialisations =======================================================
;     347 // =============================================================================================================================
;     348 TWI_Master_Initialise(); 									// Initialisation de l'interface TWI en mode Standby 
	SBIW R28,63
	SBIW R28,47
	LDI  R24,76
	LDI  R26,LOW(34)
	LDI  R27,HIGH(34)
	LDI  R30,LOW(_0xAA*2)
	LDI  R31,HIGH(_0xAA*2)
	RCALL __INITLOCB
;	Frame_I2C_LED_All_Off -> Y+108
;	Frame_I2C_LED_Switching -> Y+106
;	Frame_I2C_BP_Read -> Y+104
;	Frame_I2C_LCD_BATRON_Clear -> Y+101
;	Frame_I2C_Lcd_Line -> Y+82
;	Reset_MD23 -> Y+79
;	Mode0_MD23 -> Y+76
;	Speed1 -> Y+73
;	Speed2 -> Y+70
;	Time_OUT_Desable -> Y+67
;	Read_Reg_MD23_W -> Y+65
;	Num_Reg_MD23_1 -> R16,R17
;	Num_Reg_MD23 -> R18,R19
;	Vitesse_MD23_1 -> R20
;	Vitesse_MD23 -> R21
;	BP_I2C -> Y+64
;	Finesse_1 -> Y+63
;	Finesse -> Y+62
;	SpeedMot1 -> Y+61
;	SpeedMot1_1 -> Y+60
;	SpeedMot2 -> Y+59
;	SpeedMot2_1 -> Y+58
;	Choix_Mode_1 -> Y+57
;	Choix_Mode -> Y+56
;	Ubatt_1 -> Y+55
;	Ubatt -> Y+54
;	Version_1 -> Y+53
;	Version -> Y+52
;	Table_Registers_MD23 -> Y+34
;	Buffer_for_LCD_Line0 -> Y+17
;	Buffer_for_LCD_Line1 -> Y+0
	LDI  R16,0
	LDI  R17,0
	LDI  R18,0
	LDI  R19,0
	RCALL _TWI_Master_Initialise
;     349 // -----------------------------------------------------------------------------------------------------------------------------
;     350 // Global enable interrupts
;     351 #asm("sei")							// L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI				
	sei
;     352 // -----------------------------------------------------------------------------------------------------------------------------
;     353 TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte S_ISI 	
	MOVW R30,R28
	SUBI R30,LOW(-(108))
	SBCI R31,HIGH(-(108))
	RCALL SUBOPT_0xB
;     354 // -----------------------------------------------------------------------------------------------------------------------------
;     355 // Initialisation de l'afficheur I2C BATRON 
;     356 // -----------------------------------------------------------------------------------------------------------------------------
;     357 Init_LCD_I2C_BATRON();
	RCALL _Init_LCD_I2C_BATRON
;     358 // -----------------------------------------------------------------------------------------------------------------------------
;     359 // Affichage d'un message d'accueil
;     360 // -----------------------------------------------------------------------------------------------------------------------------
;     361 sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	RCALL SUBOPT_0xC
	LDS  R30,_Texte_Accueil_Ligne1
	LDS  R31,_Texte_Accueil_Ligne1+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     362 sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	RCALL SUBOPT_0xE
	LDS  R30,_Texte_Accueil_Ligne2
	LDS  R31,_Texte_Accueil_Ligne2+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     363 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     364 delay_ms(4000); 
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x10
;     365 // -----------------------------------------------------------------------------------------------------------------------------
;     366 // Initialisation des registres de  la carte MD23
;     367 // -----------------------------------------------------------------------------------------------------------------------------
;     368 TWI_Start_Transc_With_Data(Reset_MD23,sizeof(Reset_MD23));			
	MOVW R30,R28
	SUBI R30,LOW(-(79))
	SBCI R31,HIGH(-(79))
	RCALL SUBOPT_0x11
;     369 TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable));
	MOVW R30,R28
	SUBI R30,LOW(-(67))
	SBCI R31,HIGH(-(67))
	RCALL SUBOPT_0x11
;     370 TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(76))
	SBCI R31,HIGH(-(76))
	RCALL SUBOPT_0x11
;     371 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	RCALL SUBOPT_0x12
;     372 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));  
	RCALL SUBOPT_0x13
;     373 
;     374 // =============================================================================================================================
;     375 // ================================================ Boucle principale ==========================================================
;     376 // =============================================================================================================================
;     377 while (1)
_0xAB:
;     378       { 
;     379 // ---------------------------------------------  Champ Lecture des donnes ---------------------------------------------------- 
;     380 // Lecture de l'tat des BP
;     381 // ---------------------------------------------------------------------------------------------------------------------------- 
;     382 // Lecture des BP pour affichage sur les LED
;     383 	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));    // Envoi de l'octet d'adresse des BP: SLA+R=0x43 
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	RCALL SUBOPT_0xB
;     384 		// Rcupration de l'octet reprsentatif de l'tat des BP	
;     385 	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read)); 
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	RCALL SUBOPT_0x14
;     386 	
;     387     BP_I2C = Lire_BP_I2C();														// Lecture des BP avec gestion anti-rebond
	RCALL _Lire_BP_I2C
	__PUTB1SX 64
;     388 // ----------------------------------------------------------------------------------------------------------------------------    
;     389 // Lecture des registres de la carte MD23 
;     390    if (Menu != Reglage_Mode0_MD23)
	LDI  R30,LOW(3)
	CP   R30,R5
	BREQ _0xAE
;     391    {                                                           // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
;     392 	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W)); 
	MOVW R30,R28
	SUBI R30,LOW(-(65))
	SBCI R31,HIGH(-(65))
	RCALL SUBOPT_0xB
;     393    	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  // Envoi octet d'adresse MD23 +  bit RW=lecture  
	RCALL SUBOPT_0x15
	RCALL _TWI_Start_Transc_With_Data
;     394 	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));  
	RCALL SUBOPT_0x15
	RCALL _TWI_Get_Data_From_Transceiver
;     395    }
;     396 // ----------------------------------------------------------------------------------------------------------------------------
;     397 // --------------------------------------------------- Champ Traitement--------------------------------------------------------  
;     398     switch(Menu)
_0xAE:
	MOV  R30,R5
;     399     {// Dbut du switch1 
;     400 // -------------------------------------Dbut Menus droulants----------------------------------------------------------------- 
;     401 // Menus Niveau 1 -------------------------------------------------------------------------------------------------------------
;     402 // ----------------------------------------------------------------------------------------------------------------------------
;     403 		case Choix_Menu_Mode : if (Menu_1 != Menu)
	CPI  R30,0
	BRNE _0xB2
	CP   R5,R6
	BREQ _0xB3
;     404 			{ 
;     405 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuMode
	LDS  R31,_Ligne0MenuMode+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     406 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     407 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     408 				LCD_I2C_BATRON_gotoxy(0,15); 						 	     
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	RCALL _LCD_I2C_BATRON_gotoxy
;     409 				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0)); 
	MOVW R30,R28
	SUBI R30,LOW(-(82))
	SBCI R31,HIGH(-(82))
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,19
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     410 				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line)); 
	MOVW R30,R28
	SUBI R30,LOW(-(82))
	SBCI R31,HIGH(-(82))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(84))
	SBCI R31,HIGH(-(84))
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1B
;     411 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     412 			}
;     413      			     	
;     414 			switch (BP_I2C)
_0xB3:
	RCALL SUBOPT_0x1C
;     415 				{                                  
;     416 					case ENTR_I2C: Menu = Choix_Mode_MD23;  break; // touche Enter
	BRNE _0xB7
	RCALL SUBOPT_0x1D
	RJMP _0xB6
;     417 					case FlecheH_I2C: Menu = Choix_Menu_Infos;  break; // touche flche haut
_0xB7:
	CPI  R30,LOW(0x2)
	BRNE _0xB8
	RCALL SUBOPT_0x1E
	RJMP _0xB6
;     418 					case FlecheB_I2C: Menu = Choix_Menu_Infos;  break; // touche flche bas 
_0xB8:
	CPI  R30,LOW(0x4)
	BRNE _0xBA
	RCALL SUBOPT_0x1E
	RJMP _0xB6
;     419 					default: Menu = Choix_Menu_Mode ;
_0xBA:
	CLR  R5
;     420 				} 
_0xB6:
;     421      			      
;     422 			Menu_1 = Choix_Menu_Mode ;
	CLR  R6
;     423 		break;
	RJMP _0xB1
;     424 // ----------------------------------------------------------------------------------------------------------------------------     
;     425 		case Choix_Menu_Infos: if (Menu_1 != Menu)
_0xB2:
	CPI  R30,LOW(0x1)
	BRNE _0xBB
	CP   R5,R6
	BREQ _0xBC
;     426 			{ 
;     427 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
	RCALL SUBOPT_0xC
	LDS  R30,_Ligne0MenuInfos
	LDS  R31,_Ligne0MenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     428 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x16
	LDI  R24,0
	RCALL SUBOPT_0xD
;     429 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1); 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     430 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     431 			}
;     432      			     	
;     433 			switch (BP_I2C)
_0xBC:
	RCALL SUBOPT_0x1C
;     434 				{                                  
;     435 					case ENTR_I2C: Menu = Info_All;  break; 
	BRNE _0xC0
	LDI  R30,LOW(10)
	RJMP _0x20A
;     436 					case FlecheH_I2C: Menu = Choix_Menu_Mode;  break; 
_0xC0:
	CPI  R30,LOW(0x2)
	BRNE _0xC1
	CLR  R5
	RJMP _0xBF
;     437 					case FlecheB_I2C: Menu = Choix_Menu_Mode;  break;  
_0xC1:
	CPI  R30,LOW(0x4)
	BRNE _0xC3
	CLR  R5
	RJMP _0xBF
;     438 					default: Menu = Choix_Menu_Infos ;
_0xC3:
	LDI  R30,LOW(1)
_0x20A:
	MOV  R5,R30
;     439 				}  
_0xBF:
;     440      			      
;     441 			Menu_1 = Choix_Menu_Infos ;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     442 		break;
	RJMP _0xB1
;     443 // ----------------------------------------------------------------------------------------------------------------------------
;     444 // Menus Niveau 2 -------------------------------------------------------------------------------------------------------------
;     445 // ----------------------------------------------------------------------------------------------------------------------------     
;     446 	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
_0xBB:
	CPI  R30,LOW(0x2)
	BREQ PC+2
	RJMP _0xC4
	CP   R5,R6
	BRNE _0xC6
	LDD  R30,Y+56
	LDD  R26,Y+57
	CP   R30,R26
	BREQ _0xC5
_0xC6:
;     447 	          {
;     448 	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	RCALL SUBOPT_0xC
	__POINTW1FN _169,0
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	LDI  R24,4
	RCALL SUBOPT_0x21
;     449 	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0xD
;     450 	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     451 	        	 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     452 	        	 Choix_Mode_1 = Choix_Mode;
	LDD  R30,Y+56
	STD  Y+57,R30
;     453 	          }  
;     454 	          
;     455 	          switch (BP_I2C)
_0xC5:
	RCALL SUBOPT_0x22
;     456 				{
;     457 					case ECHAP_I2C : Menu=Choix_Menu_Mode; break;  // touche ECHAP
	BRNE _0xCB
	CLR  R5
	RJMP _0xCA
;     458 					case FlecheH_I2C: if (Choix_Mode < 3) Choix_Mode = Choix_Mode + 1; else Choix_Mode=0;  break; // touche +
_0xCB:
	CPI  R30,LOW(0x2)
	BRNE _0xCC
	LDD  R26,Y+56
	CPI  R26,LOW(0x3)
	BRSH _0xCD
	LDD  R30,Y+56
	SUBI R30,-LOW(1)
	RJMP _0x20B
_0xCD:
	CLR  R30
_0x20B:
	STD  Y+56,R30
	RJMP _0xCA
;     459 					case FlecheB_I2C: if (Choix_Mode > 0) Choix_Mode = Choix_Mode - 1; else Choix_Mode=3;  break; // touche -
_0xCC:
	CPI  R30,LOW(0x4)
	BRNE _0xCF
	LDD  R26,Y+56
	RCALL SUBOPT_0x23
	BRSH _0xD0
	LDD  R30,Y+56
	SUBI R30,LOW(1)
	RJMP _0x20C
_0xD0:
	LDI  R30,LOW(3)
_0x20C:
	STD  Y+56,R30
	RJMP _0xCA
;     460 					case ENTR_I2C: if (Choix_Mode ==0) {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Mode0_MD23;}; break;  
_0xCF:
	CPI  R30,LOW(0x40)
	BRNE _0xD4
	LDD  R30,Y+56
	CPI  R30,0
	BRNE _0xD3
	LDI  R30,LOW(128)
	STD  Y+61,R30
	STD  Y+59,R30
	LDI  R30,LOW(3)
	MOV  R5,R30
_0xD3:
	RJMP _0xCA
;     461 					default: Menu=Choix_Mode_MD23;
_0xD4:
	RCALL SUBOPT_0x1D
;     462 				}  
_0xCA:
;     463        		 	
;     464 			  Menu_1 = Choix_Mode_MD23;
	LDI  R30,LOW(2)
	MOV  R6,R30
;     465 	        break;
	RJMP _0xB1
;     466 // ----------------------------------------------------------------------------------------------------------------------------
;     467             case Reglage_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)||(Finesse_1 != Finesse))
_0xC4:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xD5
	CP   R5,R6
	BRNE _0xD7
	LDD  R30,Y+61
	LDD  R26,Y+60
	CP   R30,R26
	BRNE _0xD7
	LDD  R30,Y+59
	LDD  R26,Y+58
	CP   R30,R26
	BRNE _0xD7
	LDD  R30,Y+62
	LDD  R26,Y+63
	CP   R30,R26
	BREQ _0xD6
_0xD7:
;     468               {
;     469                 sprintf(Buffer_for_LCD_Line0,"1.%-u Mode%-u (+%-u)  ",Choix_Mode+1,Choix_Mode,Finesse);
	RCALL SUBOPT_0xC
	__POINTW1FN _169,19
	RCALL SUBOPT_0x1F
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x20
	__GETB1SX 64
	RCALL SUBOPT_0x20
	__GETB1SX 74
	RCALL SUBOPT_0x20
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     470                 sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
	RCALL SUBOPT_0xE
	__POINTW1FN _169,42
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 65
	RCALL SUBOPT_0x20
	__GETB1SX 67
	RCALL SUBOPT_0x20
	LDI  R24,8
	RCALL SUBOPT_0x24
;     471                 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
;     472                 Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     473                 SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
	LDD  R30,Y+61
	STD  Y+60,R30
	LDD  R30,Y+59
	STD  Y+58,R30
	LDD  R30,Y+62
	STD  Y+63,R30
;     474               }
;     475               
;     476               
;     477               switch (BP_I2C)
_0xD6:
	RCALL SUBOPT_0x22
;     478 				{
;     479 				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;  
	BRNE _0xDC
	LDI  R30,LOW(2)
	RJMP _0x20D
;     480 				 	
;     481 				 	case PLUS_I2C:  
_0xDC:
	CPI  R30,LOW(0x1)
	BRNE _0xDD
;     482 				 		switch (Choix_Moteur)
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     483 				 		  { 
;     484 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0xE1
	RCALL SUBOPT_0x25
	BRNE _0xE2
;     485 				 		   					if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
	LDD  R26,Y+61
	CPI  R26,LOW(0xFF)
	BRSH _0xE3
	LDD  R30,Y+61
	SUBI R30,-LOW(1)
	RJMP _0x20E
_0xE3:
	LDI  R30,LOW(255)
_0x20E:
	STD  Y+61,R30
;     486 				 		   			else    
	RJMP _0xE5
_0xE2:
;     487 				 		   					if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
	LDD  R26,Y+61
	CPI  R26,LOW(0xFA)
	BRSH _0xE6
	LDD  R30,Y+61
	SUBI R30,-LOW(5)
	RJMP _0x20F
_0xE6:
	LDI  R30,LOW(255)
_0x20F:
	STD  Y+61,R30
_0xE5:
;     488 				 		   	break;
	RJMP _0xE0
;     489 				 		   	case Moteur2: if (Finesse==1)
_0xE1:
	CPI  R30,LOW(0x1)
	BRNE _0xE0
	RCALL SUBOPT_0x25
	BRNE _0xE9
;     490 				 		   					if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
	LDD  R26,Y+59
	CPI  R26,LOW(0xFF)
	BRSH _0xEA
	LDD  R30,Y+59
	SUBI R30,-LOW(1)
	RJMP _0x210
_0xEA:
	LDI  R30,LOW(255)
_0x210:
	STD  Y+59,R30
;     491 				 		   			else    
	RJMP _0xEC
_0xE9:
;     492 				 		   					if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
	LDD  R26,Y+59
	CPI  R26,LOW(0xFA)
	BRSH _0xED
	LDD  R30,Y+59
	SUBI R30,-LOW(5)
	RJMP _0x211
_0xED:
	LDI  R30,LOW(255)
_0x211:
	STD  Y+59,R30
_0xEC:
;     493 				 		   	break;
;     494 				 		  }
_0xE0:
;     495 				 	break;
	RJMP _0xDB
;     496 				 	case MOINS_I2C:   
_0xDD:
	CPI  R30,LOW(0x8)
	BRNE _0xEF
;     497 				 	    switch (Choix_Moteur)
	CLR  R30
	SBRC R2,0
	LDI  R30,1
;     498 				 		  { 
;     499 				 		   	case Moteur1: if (Finesse==1)
	CPI  R30,0
	BRNE _0xF3
	RCALL SUBOPT_0x25
	BRNE _0xF4
;     500 				 		   					if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
	LDD  R26,Y+61
	RCALL SUBOPT_0x23
	BRSH _0xF5
	LDD  R30,Y+61
	SUBI R30,LOW(1)
	RJMP _0x212
_0xF5:
	CLR  R30
_0x212:
	STD  Y+61,R30
;     501 				 		   			else    
	RJMP _0xF7
_0xF4:
;     502 				 		   					if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0; 
	LDD  R26,Y+61
	RCALL SUBOPT_0x26
	BRSH _0xF8
	LDD  R30,Y+61
	SUBI R30,LOW(5)
	RJMP _0x213
_0xF8:
	CLR  R30
_0x213:
	STD  Y+61,R30
_0xF7:
;     503 				 		   	break;
	RJMP _0xF2
;     504 				 		   	case Moteur2: if (Finesse==1)
_0xF3:
	CPI  R30,LOW(0x1)
	BRNE _0xF2
	RCALL SUBOPT_0x25
	BRNE _0xFB
;     505 				 		   					if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
	LDD  R26,Y+59
	RCALL SUBOPT_0x23
	BRSH _0xFC
	LDD  R30,Y+59
	SUBI R30,LOW(1)
	RJMP _0x214
_0xFC:
	CLR  R30
_0x214:
	STD  Y+59,R30
;     506 				 		   			else    
	RJMP _0xFE
_0xFB:
;     507 				 		   					if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
	LDD  R26,Y+59
	RCALL SUBOPT_0x26
	BRSH _0xFF
	LDD  R30,Y+59
	SUBI R30,LOW(5)
	RJMP _0x215
_0xFF:
	CLR  R30
_0x215:
	STD  Y+59,R30
_0xFE:
;     508 				 			break;
;     509 				 		  }
_0xF2:
;     510 				 	break;
	RJMP _0xDB
;     511 				 	
;     512 				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1;
_0xEF:
	CPI  R30,LOW(0x2)
	BRNE _0x101
	RCALL SUBOPT_0x25
	BRNE _0x102
	LDI  R30,LOW(5)
	RJMP _0x216
_0x102:
	LDI  R30,LOW(1)
_0x216:
	STD  Y+62,R30
;     513 				 	break; 
	RJMP _0xDB
;     514 				 	
;     515 				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; 
_0x101:
	CPI  R30,LOW(0x4)
	BRNE _0x104
	RCALL SUBOPT_0x25
	BRNE _0x105
	LDI  R30,LOW(5)
	RJMP _0x217
_0x105:
	LDI  R30,LOW(1)
_0x217:
	STD  Y+62,R30
;     516 				 	break; 
	RJMP _0xDB
;     517 				 	
;     518 				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; 
_0x104:
	CPI  R30,LOW(0x20)
	BRNE _0x107
	SBRS R2,0
	RJMP _0x108
	CLT
	BLD  R2,0
	RJMP _0x109
_0x108:
	SET
	BLD  R2,0
_0x109:
;     519 				 	break; 
	RJMP _0xDB
;     520 				 	
;     521 				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2; 
_0x107:
	CPI  R30,LOW(0x10)
	BRNE _0x10B
	LDD  R30,Y+61
	__PUTB1SX 75
	LDD  R30,Y+59
	__PUTB1SX 72
;     522 				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	RCALL SUBOPT_0x12
;     523 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
	RCALL SUBOPT_0x13
;     524 				    break;
	RJMP _0xDB
;     525 				     
;     526 					default: Menu = Reglage_Mode0_MD23;
_0x10B:
	LDI  R30,LOW(3)
_0x20D:
	MOV  R5,R30
;     527 				}  
_0xDB:
;     528 			  Menu_1 = Reglage_Mode0_MD23;   
	LDI  R30,LOW(3)
	MOV  R6,R30
;     529 			break;
	RJMP _0xB1
;     530 // ----------------------------------------------------------------------------------------------------------------------------	        
;     531 		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];  
_0xD5:
	CPI  R30,LOW(0xA)
	BREQ PC+2
	RJMP _0x10C
	LDD  R21,Y+40
;     532 			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23)) 
	CP   R5,R6
	BRNE _0x10E
	__CPWRR 18,19,16,17
	BRNE _0x10E
	CP   R21,R20
	BREQ _0x10D
_0x10E:
;     533 			  {	
;     534 				sprintf(Buffer_for_LCD_Line0,"2.1 Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;   
	RCALL SUBOPT_0xC
	__POINTW1FN _169,58
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 18,19
	RCALL __CWD1
	RCALL __PUTPARD1
	__GETW1R 18,19
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,42
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x20
	LDI  R24,8
	RCALL SUBOPT_0x24
;     535 				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
	RCALL SUBOPT_0xE
	LDS  R30,_Ligne1PlusMoins
	LDS  R31,_Ligne1PlusMoins+1
	RCALL SUBOPT_0x27
;     536 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     537 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     538 				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
	__MOVEWRR 16,17,18,19
	MOV  R20,R21
;     539 			  }	
;     540        		              
;     541 			switch (BP_I2C)
_0x10D:
	RCALL SUBOPT_0x22
;     542 				{
;     543 					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
	BRNE _0x113
	LDI  R30,LOW(1)
	RJMP _0x218
;     544 					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break; 
_0x113:
	CPI  R30,LOW(0x1)
	BRNE _0x114
	__CPWRN 18,19,16
	BRGE _0x115
	__ADDWRN 18,19,1
	RJMP _0x116
_0x115:
	__GETWRN 18,19,0
_0x116:
	RJMP _0x112
;     545 					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break; 
_0x114:
	CPI  R30,LOW(0x8)
	BRNE _0x117
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x118
	__SUBWRN 18,19,1
	RJMP _0x119
_0x118:
	__GETWRN 18,19,16
_0x119:
	RJMP _0x112
;     546 					case FlecheH_I2C: Menu = Info_Batt;  break; 
_0x117:
	CPI  R30,LOW(0x2)
	BRNE _0x11A
	LDI  R30,LOW(8)
	RJMP _0x218
;     547 					case FlecheB_I2C: Menu = Info_Vers;  break; 
_0x11A:
	CPI  R30,LOW(0x4)
	BRNE _0x11C
	LDI  R30,LOW(9)
	RJMP _0x218
;     548 					default: Menu=Info_All;
_0x11C:
	LDI  R30,LOW(10)
_0x218:
	MOV  R5,R30
;     549 				}  
_0x112:
;     550        		 	
;     551 			Menu_1 = Info_All;		   
	LDI  R30,LOW(10)
	MOV  R6,R30
;     552 		break;       
	RJMP _0xB1
;     553 // ----------------------------------------------------------------------------------------------------------------------------	        
;     554 		case Info_Vers:	Version = Table_Registers_MD23[14];  
_0x10C:
	CPI  R30,LOW(0x9)
	BRNE _0x11D
	LDD  R30,Y+48
	STD  Y+52,R30
;     555 			if ((Menu_1 != Menu)||(Version_1 != Version)) 
	CP   R5,R6
	BRNE _0x11F
	LDD  R26,Y+53
	CP   R30,R26
	BREQ _0x11E
_0x11F:
;     556    			  {	
;     557 				sprintf(Buffer_for_LCD_Line0,"2.2 Version=%-u",Version);
	RCALL SUBOPT_0xC
	__POINTW1FN _169,74
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+56
	RCALL SUBOPT_0x20
	LDI  R24,4
	RCALL SUBOPT_0x21
;     558 				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0x28
;     559 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     560 				Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     561 				Version_1 = Version;
	LDD  R30,Y+52
	STD  Y+53,R30
;     562 			  }	
;     563        		              
;     564 			switch (BP_I2C)
_0x11E:
	RCALL SUBOPT_0x22
;     565 				{
;     566 					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
	BRNE _0x124
	LDI  R30,LOW(1)
	RJMP _0x219
;     567 					case FlecheH_I2C: Menu = Info_All;  break; 
_0x124:
	CPI  R30,LOW(0x2)
	BRNE _0x125
	LDI  R30,LOW(10)
	RJMP _0x219
;     568 					case FlecheB_I2C: Menu = Info_Batt;  break; 
_0x125:
	CPI  R30,LOW(0x4)
	BRNE _0x127
	LDI  R30,LOW(8)
	RJMP _0x219
;     569 					default: Menu=Info_Vers;
_0x127:
	LDI  R30,LOW(9)
_0x219:
	MOV  R5,R30
;     570 				}  
;     571        		 	
;     572 			Menu_1 = Info_Vers;		   
	LDI  R30,LOW(9)
	MOV  R6,R30
;     573 		break;     
	RJMP _0xB1
;     574 // ----------------------------------------------------------------------------------------------------------------------------       
;     575 		case Info_Batt:  	Ubatt = Table_Registers_MD23[11];  
_0x11D:
	CPI  R30,LOW(0x8)
	BRNE _0xB1
	LDD  R30,Y+45
	STD  Y+54,R30
;     576 			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt)) 
	CP   R5,R6
	BRNE _0x12A
	LDD  R26,Y+55
	CP   R30,R26
	BREQ _0x129
_0x12A:
;     577    			  {	
;     578 					sprintf(Buffer_for_LCD_Line0,"2.3 Ubatt=%-u.%-uV",Ubatt/10, Ubatt-10*(Ubatt/10));
	RCALL SUBOPT_0xC
	__POINTW1FN _169,90
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+58
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x20
	LDD  R26,Y+62
	RCALL SUBOPT_0x29
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	LDD  R26,Y+62
	RCALL __SWAPB12
	SUB  R30,R26
	RCALL SUBOPT_0x20
	LDI  R24,8
	RCALL SUBOPT_0x24
;     579 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x28
;     580 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);  
	RCALL SUBOPT_0xF
;     581 					Display_Arrow_0n_I2C_LCDBATRON();
	RCALL _Display_Arrow_0n_I2C_LCDBATRON
;     582 					Ubatt_1 = Ubatt;
	LDD  R30,Y+54
	STD  Y+55,R30
;     583 			  }	
;     584        		              
;     585 			switch (BP_I2C)
_0x129:
	RCALL SUBOPT_0x22
;     586 				{
;     587 					case ECHAP_I2C : Menu=Choix_Menu_Infos; break;  
	BRNE _0x12F
	LDI  R30,LOW(1)
	RJMP _0x21A
;     588 					case FlecheH_I2C: Menu = Info_Vers;  break; 
_0x12F:
	CPI  R30,LOW(0x2)
	BRNE _0x130
	LDI  R30,LOW(9)
	RJMP _0x21A
;     589 					case FlecheB_I2C: Menu = Info_All;  break; 
_0x130:
	CPI  R30,LOW(0x4)
	BRNE _0x132
	LDI  R30,LOW(10)
	RJMP _0x21A
;     590 					default: Menu=Info_Batt;
_0x132:
	LDI  R30,LOW(8)
_0x21A:
	MOV  R5,R30
;     591 				}  
;     592        		 	
;     593 			Menu_1 = Info_Batt;
	LDI  R30,LOW(8)
	MOV  R6,R30
;     594 		break;   
;     595 // ----------------------------------------------------------------------------------------------------------------------------       
;     596 	
;     597     }// Fin du switch1  
_0xB1:
;     598        
;     599     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];  
	MOVW R30,R28
	SUBI R30,LOW(-(106))
	SBCI R31,HIGH(-(106))
	ADIW R30,1
	PUSH R31
	PUSH R30
	__GETB1SX 105
	COM  R30
	POP  R26
	POP  R27
	ST   X,R30
;     600 // ----------------------------------------------------------------------------------------------------------------------------
;     601 // ----------------------------------------  Champ Ecriture des rsultats  ----------------------------------------------------
;     602 // Ecriture sur les LED                              	
;     603     TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(106))
	SBCI R31,HIGH(-(106))
	RCALL SUBOPT_0xB
;     604 // ----------------------------------------------------------------------------------------------------------------------------  
;     605  // delay_ms(100);   // A utiliser pour visualiser les trames I2C
;     606   }; // Fin while(1)
	RJMP _0xAB
;     607       
;     608 } //Fin main  
	ADIW R28,63
	ADIW R28,47
_0x133:
	RJMP _0x133
;     609 
;     610 
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x2A
	SBIW R30,0
	BREQ _0x16A
	RCALL SUBOPT_0x2A
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x16B
_0x16A:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x16B:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x16D:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x16F
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x173
	CPI  R19,37
	BRNE _0x174
	LDI  R16,LOW(1)
	RJMP _0x175
_0x174:
	RCALL SUBOPT_0x2B
_0x175:
	RJMP _0x172
_0x173:
	CPI  R30,LOW(0x1)
	BRNE _0x176
	CPI  R19,37
	BRNE _0x177
	RCALL SUBOPT_0x2B
	LDI  R16,LOW(0)
	RJMP _0x172
_0x177:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x178
	LDI  R17,LOW(1)
	RJMP _0x172
_0x178:
	CPI  R19,43
	BRNE _0x179
	LDI  R21,LOW(43)
	RJMP _0x172
_0x179:
	CPI  R19,32
	BRNE _0x17A
	LDI  R21,LOW(32)
	RJMP _0x172
_0x17A:
	RJMP _0x17B
_0x176:
	CPI  R30,LOW(0x2)
	BRNE _0x17C
_0x17B:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x17D
	ORI  R17,LOW(128)
	RJMP _0x172
_0x17D:
	RJMP _0x17E
_0x17C:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x172
_0x17E:
	CPI  R19,48
	BRLO _0x181
	CPI  R19,58
	BRLO _0x182
_0x181:
	RJMP _0x180
_0x182:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x172
_0x180:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x186
	RCALL SUBOPT_0x2C
	LD   R30,X
	RCALL SUBOPT_0x2D
	RJMP _0x187
_0x186:
	CPI  R30,LOW(0x73)
	BRNE _0x189
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x19
	MOV  R16,R30
	RJMP _0x18A
_0x189:
	CPI  R30,LOW(0x70)
	BRNE _0x18C
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2E
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x18A:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x18D
_0x18C:
	CPI  R30,LOW(0x64)
	BREQ _0x190
	CPI  R30,LOW(0x69)
	BRNE _0x191
_0x190:
	ORI  R17,LOW(4)
	RJMP _0x192
_0x191:
	CPI  R30,LOW(0x75)
	BRNE _0x193
_0x192:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x194
_0x193:
	CPI  R30,LOW(0x58)
	BRNE _0x196
	ORI  R17,LOW(8)
	RJMP _0x197
_0x196:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x1C5
_0x197:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x194:
	SBRS R17,2
	RJMP _0x199
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2F
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x19A
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x19A:
	CPI  R21,0
	BREQ _0x19B
	SUBI R16,-LOW(1)
	RJMP _0x19C
_0x19B:
	ANDI R17,LOW(251)
_0x19C:
	RJMP _0x19D
_0x199:
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2F
_0x19D:
_0x18D:
	SBRC R17,0
	RJMP _0x19E
_0x19F:
	CP   R16,R20
	BRSH _0x1A1
	SBRS R17,7
	RJMP _0x1A2
	SBRS R17,2
	RJMP _0x1A3
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x1A4
_0x1A3:
	LDI  R19,LOW(48)
_0x1A4:
	RJMP _0x1A5
_0x1A2:
	LDI  R19,LOW(32)
_0x1A5:
	RCALL SUBOPT_0x2B
	SUBI R20,LOW(1)
	RJMP _0x19F
_0x1A1:
_0x19E:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x1A6
_0x1A7:
	CPI  R18,0
	BREQ _0x1A9
	SBRS R17,3
	RJMP _0x1AA
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x21B
_0x1AA:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x21B:
	ST   -Y,R30
	RCALL SUBOPT_0x30
	CPI  R20,0
	BREQ _0x1AC
	SUBI R20,LOW(1)
_0x1AC:
	SUBI R18,LOW(1)
	RJMP _0x1A7
_0x1A9:
	RJMP _0x1AD
_0x1A6:
_0x1AF:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x1B1
	SBRS R17,3
	RJMP _0x1B2
	SUBI R19,-LOW(7)
	RJMP _0x1B3
_0x1B2:
	SUBI R19,-LOW(39)
_0x1B3:
_0x1B1:
	SBRC R17,4
	RJMP _0x1B5
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x1B7
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x1B6
_0x1B7:
	ORI  R17,LOW(16)
	RJMP _0x1B9
_0x1B6:
	CP   R20,R18
	BRLO _0x1BB
	SBRS R17,0
	RJMP _0x1BC
_0x1BB:
	RJMP _0x1BA
_0x1BC:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x1BD
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x1B9:
	SBRS R17,2
	RJMP _0x1BE
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x30
	CPI  R20,0
	BREQ _0x1BF
	SUBI R20,LOW(1)
_0x1BF:
_0x1BE:
_0x1BD:
_0x1B5:
	RCALL SUBOPT_0x2B
	CPI  R20,0
	BREQ _0x1C0
	SUBI R20,LOW(1)
_0x1C0:
_0x1BA:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x1B0
	RJMP _0x1AF
_0x1B0:
_0x1AD:
	SBRS R17,0
	RJMP _0x1C1
_0x1C2:
	CPI  R20,0
	BREQ _0x1C4
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x2D
	RJMP _0x1C2
_0x1C4:
_0x1C1:
_0x1C5:
_0x187:
	LDI  R16,LOW(0)
_0x172:
	RJMP _0x16D
_0x16F:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x31
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x31
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x32
	ADIW R28,4
	RET
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1DC*2)
	LDI  R31,HIGH(_0x1DC*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0xE
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x1B
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R24,3
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1DE*2)
	LDI  R31,HIGH(_0x1DE*2)
	RCALL __INITLOCB
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x1E0
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x1E1
_0x1E0:
	RJMP _0x1DF
_0x1E1:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x1E5
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	STD  Y+2,R30
	RJMP _0x1E4
_0x1E5:
	CPI  R30,LOW(0x1)
	BRNE _0x1E4
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
	STD  Y+2,R30
_0x1E4:
_0x1DF:
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x33
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	SBIW R28,4
	RCALL __SAVELOCR2
	LDD  R30,Y+8
	CLR  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+9
	SUBI R30,-LOW(2)
	CLR  R31
	STD  Y+2,R30
	STD  Y+2+1,R31
	__GETWRN 16,17,0
_0x1E9:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x1EA
	RCALL SUBOPT_0x34
	CPI  R26,LOW(0x5B)
	BRNE _0x1EB
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(138)
	ST   X,R30
	RJMP _0x1EC
_0x1EB:
	RCALL SUBOPT_0x34
	CPI  R26,LOW(0x5D)
	BRNE _0x1ED
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(84)
	RJMP _0x21C
_0x1ED:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X
	SUBI R30,-LOW(128)
	LDD  R26,Y+2
	LDD  R27,Y+2+1
_0x21C:
	ST   X,R30
_0x1EC:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	__ADDWRN 16,17,1
	RJMP _0x1E9
_0x1EA:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0x32
	RCALL __LOADLOCR2
	ADIW R28,10
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,20
	LDI  R24,19
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1F0*2)
	LDI  R31,HIGH(_0x1F0*2)
	RCALL __INITLOCB
	CLR  R30
	STD  Y+19,R30
_0x1F2:
	LDD  R26,Y+19
	CPI  R26,LOW(0x2)
	BRSH _0x1F3
	RCALL SUBOPT_0x17
	LDD  R30,Y+20
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1B
	LDD  R30,Y+19
	SUBI R30,-LOW(1)
	STD  Y+19,R30
	RJMP _0x1F2
_0x1F3:
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x17
	RCALL _LCD_I2C_BATRON_gotoxy
	RCALL SUBOPT_0x37
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x37
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x1B
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R24,6
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1F5*2)
	LDI  R31,HIGH(_0x1F5*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x17
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x33
	ADIW R28,6
	RET
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R24,2
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x1F7*2)
	LDI  R31,HIGH(_0x1F7*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	LDD  R17,Y+3
	MOV  R30,R7
	CPI  R30,0
	BRNE _0x1FB
	CPI  R17,0
	BRNE _0x1FC
	MOV  R16,R17
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	LDD  R17,Y+3
	CP   R17,R16
	BRNE _0x1FD
	LDI  R30,LOW(1)
	MOV  R7,R30
	CLR  R30
	RJMP _0x205
_0x1FD:
	LDI  R30,LOW(255)
	RJMP _0x205
	RJMP _0x1FF
_0x1FC:
	LDI  R30,LOW(255)
	RJMP _0x205
_0x1FF:
	RJMP _0x1FA
_0x1FB:
	CPI  R30,LOW(0x1)
	BRNE _0x1FA
	CPI  R17,0
	BREQ _0x201
	MOV  R16,R17
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	LDD  R17,Y+3
	CP   R17,R16
	BRNE _0x202
	CLR  R7
	MOV  R30,R17
	RJMP _0x205
_0x202:
	CLR  R30
	RJMP _0x205
	RJMP _0x204
_0x201:
	CLR  R30
_0x204:
_0x1FA:
_0x205:
	RCALL __LOADLOCR2
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LDD  R30,Y+1
	LD   R26,Y
	CP   R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LD   R30,Y
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	MOV  R30,R4
	INC  R4
	CLR  R31
	SUBI R30,LOW(-_TWI_buf_G1)
	SBCI R31,HIGH(-_TWI_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDS  R30,_TWI_statusReg
	ANDI R30,0xFE
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	IN   R30,0x3
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES
SUBOPT_0xC:
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0xD:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0xE:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0xF:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Displ_2Lines_On_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x11:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	MOVW R30,R28
	SUBI R30,LOW(-(73))
	SBCI R31,HIGH(-(73))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	MOVW R30,R28
	SUBI R30,LOW(-(70))
	SBCI R31,HIGH(-(70))
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x14:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RJMP _TWI_Get_Data_From_Transceiver

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	MOVW R30,R28
	ADIW R30,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x17:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(15)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x19:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _strlen

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Built_Strng_Fram_I2C_LCDBATRON

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x1B:
	ST   -Y,R30
	RJMP _TWI_Start_Transc_With_Data

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	__GETB1SX 64
	CPI  R30,LOW(0x40)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	LDI  R30,LOW(2)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1E:
	LDI  R30,LOW(1)
	MOV  R5,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+60
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x20:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x22:
	__GETB1SX 64
	CPI  R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x23:
	CLR  R30
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x24:
	RCALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x25:
	LDD  R26,Y+62
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	LDI  R30,LOW(5)
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x27:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strcpyf
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	RJMP SUBOPT_0x27

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x29:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2B:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x2C:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2E:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	CLR  R30
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	LDI  R30,LOW(3)
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R26,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x35:
	ST   -Y,R30
	RJMP _LCD_I2C_BATRON_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x36:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	MOVW R30,R28
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x38:
	LDI  R30,LOW(1)
	RJMP SUBOPT_0x35

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x39:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3A:
	MOVW R30,R28
	ADIW R30,2
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x10

_strcpyf:
	ld   r30,y+
	ld   r31,y+
	ld   r26,y+
	ld   r27,y+
	movw r24,r26
__strcpyf0:
	lpm  r0,z+
	st   x+,r0
	tst  r0
	brne __strcpyf0
	movw r30,r24
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

